Subject: bug#19390: 25.0.50; `package-activate' is too slow

From: Stefan Monnier <[email-masked]>
Date: Thu, 18 Dec 2014 13:40:37 -0500

>> I don't think this performance hit will be noticeable during regular
>> package loading.
> It'll probably slow down Emacs startup: `require' will have to call
> `find-library-name' for each common feature that someone depends on, each
> time a dependant is loaded.

And more importantly, we suffer the slow down when require is supposed to
be fast (i.e. when the package has already been loaded), so the relative
speed impact is not negligible.

And doing it in `require' doesn't catch all cases, because it's done too
lazily and doesn't account for packages loaded via autoloads.  Doing the
reloads eagerly when a package is (re)activated is the better choice.

        Stefan